<!-- 
   - ~/ffalh/fflib/README.md
   - =======================
   - 
   - 
   -  ______ ______   _      _____ ____                                                              
   - |  ____|  ____| | |    |_   _|  _ \    ____  _____    _    ____  __  __ _____                 _ 
   - | |__  | |__    | |      | | | |_) |  |  _ \| ____|  / \  |  _ \|  \/  | ____|  _ __ ___   __| |
   - |  __| |  __|   | |      | | |  _ <   | |_) |  _|   / _ \ | | | | |\/| |  _|   | '_ ` _ \ / _` |
   - | |    | |      | |____ _| |_| |_) |  |  _ <| |___ / ___ \| |_| | |  | | |___ _| | | | | | (_| |
   - |_|    |_|      |______|_____|____/   |_| \_\_____/_/   \_\____/|_|  |_|_____(_)_| |_| |_|\__,_|
   -                                                                                                 
   -                                                                                                 
   - 
   - [[http://www.ljll.fr/lehyaric][Antoine Le Hyaric]]
   - 
   - Sorbonne Universit, CNRS, Laboratoire Jacques-Louis Lions, F-75005, Paris, France
   - 
   - ----------------------------
   - This file is part of FreeFEM
   - ----------------------------
   - FreeFEM is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as
   - published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.
   - FreeFEM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
   - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
   - You should have received a copy of the GNU Lesser General Public License along with FreeFEM; if not, write to the Free Software
   - Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
   - 
   - _TODO_ [[file:::53]]
   - [[elisp:(progn (org-link-minor-mode) (setq org-link-descriptive nil) (org-toggle-link-display))][hide links]] [[elisp:(progn (org-link-minor-mode) (setq org-link-descriptive t) (org-toggle-link-display))][show links]] [[elisp:(alh-1dex-open)][open 1dex]] [[elisp:(alh-1dex-update)][update 1dex]]
   - 
   - [[elisp:(alh-set-keywords)][set keywords]] ([[file:~/alh/bin/headeralh][headeralh]])
   - emacs-keywords freefem markdown start=11/06/24 univ update=20/06/24
   -->

<!-- [[https://docs.github.com/fr/get-started/writing-on-github/getting-started-with-writing-and-formatting-on-github/basic-writing-and-formatting-syntax]] -->

## Package of numerical libraries for Javascript [FreeFEM](https://www.freefem.org)

Version 24.1

Contains well-known numerical libraries (BLAS, LAPACK, etc) compiled in Javascript for FreeFEM. Generating Javascript output requires
cross-compiling, which is not usually provided in the building procedure of these libraries. This `Makefile` generates the required
cross-compilation directives and produces a single Javascript lib.

The main target is [emscripten](https://emscripten.org), but other compilers can be used by setting `$(CXX)` and `$(CXXFLAGS)`.  The three
main binary output formats are dev (development version), min (optimized for speed and minimum size) and native. cf the ffjs Makefile for
more details.  Optimized options are available (mainly `-Os`), but without compromising on portability.

Many thanks to the projects included in this library:
- [BLAS](https://www.netlib.org/blas/)
- [CBLAS](https://www.netlib.org/blas/#_cblas)
- [LAPACK](https://www.netlib.org/lapack/)
- [ARPACK](https://www.arpack.org/)
- Umfpack from [SuiteSparse](https://people.engr.tamu.edu/davis/suitesparse.html)
- [TetGen](https://wias-berlin.de/software/index.jsp?id=TetGen&lang=1)
- [f2c](https://www.netlib.org/f2c/) (used to translate Fortran sources into C)

More libraries may be added, depending on the needs for FreeFEM.

This project ([web page](https://www.ljll.fr/lehyaric/ffcs/fflib.htm), [github](https://github.com/alh104/fflib)) has been initiated as a
tool for the [ffjs](https://www.ljll.fr/lehyaric/ffjs) project, which is the Javascript version of FreeFEM, but it can be used standalone.

Questions, comments and patches are welcome on the [FreeFEM forum](https://community.freefem.org).

## Build commands

Building the default (native) binary version (result in `bin_default/libfflib.a`):

```
make -j binary
```

Creating binaries for any architecture (result in `bin_[arch]/libfflib.a`) (please refer to the [[ffjs](https://www.ljll.fr/lehyaric/ffjs) project for the right options for Javascript):
```
make -j BINTAG=[arch] BINGOAL=all
```

All usual make variables (CXX, CXXFLAGS, etc) are available.

<!-- 
   - Local Variables:
   - mode:markdown
   - indent-tabs-mode:nil
   - eval:(visual-line-mode t)
   - coding:utf-8
   - eval:(flyspell-mode)
   - eval:(outline-minor-mode)
   - eval:(org-link-minor-mode)
   - End:
   -->
<!-- LocalWords: emacs
   -->
